<?php

namespace Teste\Teste\Policies;

use Litepie\User\Contracts\UserPolicy;
use Teste\Teste\Models\Dsdffff;

class DsdffffPolicy
{

    /**
     * Determine if the given user can view the dsdffff.
     *
     * @param UserPolicy $user
     * @param Dsdffff $dsdffff
     *
     * @return bool
     */
    public function view(UserPolicy $user, Dsdffff $dsdffff)
    {
        if ($user->canDo('teste.dsdffff.view') && $user->isAdmin()) {
            return true;
        }

        return $dsdffff->user_id == user_id() && $dsdffff->user_type == user_type();
    }

    /**
     * Determine if the given user can create a dsdffff.
     *
     * @param UserPolicy $user
     * @param Dsdffff $dsdffff
     *
     * @return bool
     */
    public function create(UserPolicy $user)
    {
        return  $user->canDo('teste.dsdffff.create');
    }

    /**
     * Determine if the given user can update the given dsdffff.
     *
     * @param UserPolicy $user
     * @param Dsdffff $dsdffff
     *
     * @return bool
     */
    public function update(UserPolicy $user, Dsdffff $dsdffff)
    {
        if ($user->canDo('teste.dsdffff.edit') && $user->isAdmin()) {
            return true;
        }

        return $dsdffff->user_id == user_id() && $dsdffff->user_type == user_type();
    }

    /**
     * Determine if the given user can delete the given dsdffff.
     *
     * @param UserPolicy $user
     * @param Dsdffff $dsdffff
     *
     * @return bool
     */
    public function destroy(UserPolicy $user, Dsdffff $dsdffff)
    {
        return $dsdffff->user_id == user_id() && $dsdffff->user_type == user_type();
    }

    /**
     * Determine if the given user can verify the given dsdffff.
     *
     * @param UserPolicy $user
     * @param Dsdffff $dsdffff
     *
     * @return bool
     */
    public function verify(UserPolicy $user, Dsdffff $dsdffff)
    {
        if ($user->canDo('teste.dsdffff.verify')) {
            return true;
        }

        return false;
    }

    /**
     * Determine if the given user can approve the given dsdffff.
     *
     * @param UserPolicy $user
     * @param Dsdffff $dsdffff
     *
     * @return bool
     */
    public function approve(UserPolicy $user, Dsdffff $dsdffff)
    {
        if ($user->canDo('teste.dsdffff.approve')) {
            return true;
        }

        return false;
    }

    /**
     * Determine if the user can perform a given action ve.
     *
     * @param [type] $user    [description]
     * @param [type] $ability [description]
     *
     * @return [type] [description]
     */
    public function before($user, $ability)
    {
        if ($user->isSuperuser()) {
            return true;
        }
    }
}
